Index: Build
===================================================================
RCS file: Build
diff -N Build
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ Build	6 May 2005 13:00:25 -0000	1.3
@@ -0,0 +1,22 @@
+#!/bin/sh
+
+source ../../Config.sh
+
+if [ $PP_BUILD_ARCH = "arm" ]; then
+    SECTIONS_OPTIONS=""
+else
+    SECTIONS_OPTIONS="-ffunction-sections -fdata-sections"
+fi
+
+pp_build_local () {
+    mkdir -p bin library \
+    && autoconf \
+    && CFLAGS="$FW_CFLAGS_3RDPARTY $SECTIONS_OPTIONS -D_GNU_SOURCE" \
+       ./configure	--host="$HOST_SYSTEM" \
+			--prefix=/ \
+			--disable-static \
+			--with-kernel-dir="${FW_TOPDIR}/${LINUX_KERNEL_DIR}" \
+    && make all install
+}
+
+pp_do "$@"
Index: configure.in
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/configure.in,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- configure.in	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ configure.in	21 Apr 2005 11:59:59 -0000	1.2
@@ -42,55 +42,53 @@
   !!! Can not include OpenSSL headers files.            !!!]))
 
 dnl ----[ Checks for libraries ]----
-AC_CHECK_LIB(crypto, MD5_Init,,AC_MSG_ERROR([OpenSSL libraries are required]))
-AC_CHECK_LIB(ssl, SSL_CTX_new,,AC_MSG_ERROR([OpenSSL libraries are required]))
-AC_CHECK_LIB(popt, poptGetContext,,AC_MSG_ERROR([Popt libraries is required]))
+#AC_CHECK_LIB(crypto, MD5_Init,,AC_MSG_ERROR([OpenSSL libraries are required]))
+#AC_CHECK_LIB(ssl, SSL_CTX_new,,AC_MSG_ERROR([OpenSSL libraries are required]))
+#AC_CHECK_LIB(popt, poptGetContext,,AC_MSG_ERROR([Popt libraries is required]))
+AC_CHECK_LIB(pthread, sem_wait,,AC_MSG_ERROR([Pthread library is required]))
 
 dnl ----[ Kernel version check ]----
 CPPFLAGS="$CPPFLAGS -I$kernelinc"
 AC_MSG_CHECKING([for kernel version])
-AC_TRY_RUN([
-    #include <stdlib.h>
-    #include <stdio.h>
-    #include <linux/version.h>
-    int main (void) {
-      FILE *fp = fopen ("linuxinfo", "w");
-      if (!fp) return 1;
-      fprintf (fp, "%s\n", UTS_RELEASE);
-      fclose (fp); 
-      return 0;
-    } 
-  ], [
-    LINUX_MAJOR=`cat linuxinfo | cut -d'.' -f1`
-    LINUX_MINOR=`cat linuxinfo | cut -d'.' -f2`
-    LINUX_PATCH=`cat linuxinfo | cut -d'.' -f3`
-  ], [
-    LINUX_MAJOR="0"
-    LINUX_MINOR="0"
-    LINUX_PATCH="0"
-  ], [
-    LINUX_MAJOR="0"
-    LINUX_MINOR="0"
-    LINUX_PATCH="0"
-  ])
-  rm -f linuxinfo
-  AC_MSG_RESULT([$LINUX_MAJOR.$LINUX_MINOR.$LINUX_PATCH])
-  if test "$LINUX_MINOR" = "6"; then
-    KERN="_KRNL_2_6_"
-  elif test "$LINUX_MINOR" = "4"; then
-    KERN="_KRNL_2_4_"
-  else
-    KERN="_KRNL_2_2_"
-  fi
-  if test "$LINUX_MAJOR" = "0" -a "$LINUX_MINOR" = "0" -a "$LINUX_PATCH" = "0"; then
-    AC_MSG_WARN([Cannot determine Linux Kernel version.])
-  fi
+cat > __mytest.c <<EOF
+#include <stdlib.h>
+#include <stdio.h>
+#include <linux/version.h>
+int main (void) {
+    FILE *fp = fopen ("linuxinfo", "w");
+    if (!fp) return 1;
+    fprintf (fp, "%s\n", UTS_RELEASE);
+    fclose (fp); 
+    return 0;
+}
+EOF
+if gcc ${CPPFLAGS} -o __mytest __mytest.c > /dev/null 2>&1 && ./__mytest > /dev/null 2>&1 ; then
+  LINUX_MAJOR=`cat linuxinfo | cut -d'.' -f1`
+  LINUX_MINOR=`cat linuxinfo | cut -d'.' -f2`
+  LINUX_PATCH=`cat linuxinfo | cut -d'.' -f3`
+else
+  LINUX_MAJOR="0"
+  LINUX_MINOR="0"
+  LINUX_PATCH="0"
+fi
+rm -f linuxinfo __mytest __mytest.c
+AC_MSG_RESULT([$LINUX_MAJOR.$LINUX_MINOR.$LINUX_PATCH])
+if test "$LINUX_MINOR" = "6"; then
+  KERN="_KRNL_2_6_"
+elif test "$LINUX_MINOR" = "4"; then
+  KERN="_KRNL_2_4_"
+else
+  KERN="_KRNL_2_2_"
+fi
+if test "$LINUX_MAJOR" = "0" -a "$LINUX_MINOR" = "0" -a "$LINUX_PATCH" = "0"; then
+  AC_MSG_WARN([Cannot determine Linux Kernel version.])
+fi
 
-AC_CHECK_FILE(/usr/src/linux/net/core/link_watch.c, [
-                LINKWATCH_SUPPORT="_WITH_LINKWATCH_"
-              ], [
-                LINKWATCH_SUPPORT="_WITHOUT_LINKWATCH_"
-              ])
+if [ -r $kernelinc/../net/core/link_watch.c ]; then
+  LINKWATCH_SUPPORT="_WITH_LINKWATCH_"
+else
+  LINKWATCH_SUPPORT="_WITHOUT_LINKWATCH_"
+fi
 
 AC_SUBST(LINKWATCH_SUPPORT)
 AC_SUBST(KERN)
@@ -111,31 +109,28 @@
 
 if test "$IPVS_SUPPORT" = "_WITH_LVS_"; then
   AC_MSG_CHECKING([for IPVS version])
-  AC_TRY_RUN([ 
-    #include <stdlib.h>
-    #include <stdio.h>
-    #include <net/ip_vs.h>
-    int main (void) {
-      FILE *fp = fopen ("ipvsinfo", "w");
-      if (!fp) return 1;
-      fprintf (fp, "%d\n%d\n%d\n", NVERSION(IP_VS_VERSION_CODE));
-      fclose (fp); 
-      return 0;
-    } 
-  ], [
+  cat > __mytest.c <<EOF
+#include <stdlib.h>
+#include <stdio.h>
+#include <net/ip_vs.h>
+int main (void) {
+    FILE *fp = fopen ("ipvsinfo", "w");
+    if (!fp) return 1;
+    fprintf (fp, "%d\n%d\n%d\n", NVERSION(IP_VS_VERSION_CODE));
+    fclose (fp); 
+    return 0;
+}
+EOF
+  if gcc ${CPPFLAGS} -o __mytest __mytest.c > /dev/null 2>&1 && ./__mytest > /dev/null 2>&1 ; then
     IPVS_MAJOR=`head -n 1 ipvsinfo | tail -n 1`
     IPVS_MINOR=`head -n 2 ipvsinfo | tail -n 1`
     IPVS_PATCH=`head -n 3 ipvsinfo | tail -n 1`
-  ], [
-    IPVS_MAJOR="0"
-    IPVS_MINOR="0"
-    IPVS_PATCH="0"
-  ], [
+  else
     IPVS_MAJOR="0"
     IPVS_MINOR="0"
     IPVS_PATCH="0"
-  ])
-  rm -f ipvsinfo
+  fi
+  rm -f ipvsinfo __mytest __mytest.c
   AC_MSG_RESULT([$IPVS_MAJOR.$IPVS_MINOR.$IPVS_PATCH])
   if test "$IPVS_MAJOR" = "0" -a "$IPVS_MINOR" = "0" -a "$IPVS_PATCH" = "0"; then
     AC_MSG_WARN([Cannot determine IPVS version.])
@@ -195,7 +190,8 @@
     ], [
       AC_MSG_RESULT(no)
     ], [
-      AC_MSG_RESULT(no)
+      AC_MSG_RESULT(yes)
+      VRRP_SUPPORT="_WITH_VRRP_"
     ])
 fi
 
Index: genhash/http.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/genhash/http.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- genhash/http.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ genhash/http.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -32,9 +32,6 @@
 #include "html.h"
 #include "timer.h"
 
-/* extern variables */
-extern REQ *req;
-
 /* 
  * The global design of this checker is the following :
  * 
@@ -138,17 +135,17 @@
 			if (r) {
 				if (req->verbose)
 					print_buffer(r, sock->extracted);
-				memcpy(sock->buffer, sock->extracted, r);
+				memmove(sock->buffer, sock->extracted, r);
 				MD5_Update(&sock->context, sock->buffer, r);
 				r = 0;
 			}
 			sock->size = r;
 		} else {
 			/* minimize buffer using no 2*CR/LF found yet */
-			if (sock->size > 3) {
-				memcpy(sock->buffer,
-				       sock->buffer + sock->size - 3, 3);
-				sock->size = 3;
+			if (sock->size > 4) {
+				memmove(sock->buffer,
+					sock->buffer + sock->size - 4, 4);
+				sock->size = 4;
 			}
 		}
 	} else if (sock->size) {
@@ -173,8 +170,7 @@
 		return epilog(thread);
 
 	/* read the HTTP stream */
-	memset(sock->buffer, 0, MAX_BUFFER_LENGTH);
-	r = read(thread->u.fd, sock->buffer, MAX_BUFFER_LENGTH);
+	r = read(thread->u.fd, sock->buffer + sock->size, MAX_BUFFER_LENGTH - sock->size);
 
 	DBG(" [l:%d,fd:%d]\n", r, sock->fd);
 
Index: genhash/main.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/genhash/main.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- genhash/main.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ genhash/main.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -30,8 +30,7 @@
 #include "sock.h"
 
 /* global var */
-thread_master *master = NULL;
-SOCK *sock = NULL;
+REQ *req;                /* Cmd line arguments */
 
 /* Terminate handler */
 void
@@ -191,7 +190,7 @@
 }
 
 int
-main(int argc, char **argv)
+genhash_main(int argc, char **argv)
 {
 	thread thread;
 
Index: genhash/main.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/genhash/main.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- genhash/main.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ genhash/main.h	21 Apr 2005 11:59:59 -0000	1.2
@@ -71,8 +71,7 @@
 } REQ;
 
 /* Global variables */
-REQ *req;			/* Cmd line arguments */
-unsigned int debug;
+extern REQ *req;		/* Cmd line arguments */
 
 /* Data buffer length description */
 #define BUFSIZE             1024
Index: genhash/sock.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/genhash/sock.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- genhash/sock.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ genhash/sock.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -31,9 +31,8 @@
 #include "ssl.h"
 #include "main.h"
 
-/* extern var */
-extern thread_master *master;
-extern SOCK *sock;
+/* global vars */
+SOCK *sock = NULL;
 
 /* Close the descriptor */
 static void
Index: genhash/sock.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/genhash/sock.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- genhash/sock.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ genhash/sock.h	21 Apr 2005 11:59:59 -0000	1.2
@@ -43,6 +43,9 @@
 	int total_size;
 } SOCK;
 
+/* global vars exported */
+extern SOCK *sock;
+
 /* Prototypes */
 extern void free_sock(SOCK * sock);
 extern void init_sock(void);
Index: keepalived/check/check_api.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_api.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_api.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_api.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -23,6 +23,7 @@
  */
 
 #include "check_api.h"
+#include "main.h"
 #include "parser.h"
 #include "memory.h"
 #include "utils.h"
@@ -31,12 +32,8 @@
 #include "check_http.h"
 #include "check_ssl.h"
 
-/* External vars */
-extern thread_master *master;
-extern check_conf_data *check_data;
-extern unsigned int debug;
-
 /* Global vars */
+list checkers_queue;
 static checker_id_t ncheckers = 0;
 
 /* free checker data */
Index: keepalived/check/check_daemon.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_daemon.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_daemon.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_daemon.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -32,6 +32,7 @@
 #include "pidfile.h"
 #include "daemon.h"
 #include "list.h"
+#include "main.h"
 #include "memory.h"
 #include "parser.h"
 #include "watchdog.h"
@@ -39,12 +40,10 @@
 #include "vrrp_if.h"
 
 /* Global vars */
-check_conf_data *check_data;
-check_conf_data *old_check_data;
-int check_wdog_sd = -1;
+static int check_wdog_sd = -1;
 
 /* Healthchecker watchdog data */
-wdog_data check_wdog_data = {
+static wdog_data check_wdog_data = {
 	"Healthcheck Child",
 	WDOG_CHECK,
 	-1,
@@ -52,16 +51,6 @@
 	start_check_child
 };
 
-/* Externals vars */
-extern thread_master *master;
-extern conf_data *data;
-extern unsigned int debug;
-extern int reload;
-extern pid_t checkers_child;
-extern char *conf_file;
-extern int init_ssl_ctx(void);
-extern int wdog_delay_check;
-
 /* Daemon stop sequence */
 static void
 stop_check(void)
Index: keepalived/check/check_data.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_data.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_data.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_data.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -27,8 +27,9 @@
 #include "memory.h"
 #include "utils.h"
 
-/* Externals vars */
-extern check_conf_data *check_data;
+/* global vars */
+check_conf_data *check_data = NULL;
+check_conf_data *old_check_data = NULL;
 
 /* SSL facility functions */
 SSL_DATA *
Index: keepalived/check/check_http.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_http.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_http.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_http.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -505,12 +505,14 @@
 {
 	req->len += r;
 	if (!req->extracted) {
+		if (!req->status_code) {
+			req->status_code = extract_status_code(req->buffer, req->len);
+		}
 		if ((req->extracted =
 		     extract_html(req->buffer, req->len))) {
-			req->status_code = extract_status_code(req->buffer, req->len);
 			r = req->len - (req->extracted - req->buffer);
 			if (r) {
-				memcpy(req->buffer, req->extracted, r);
+				memmove(req->buffer, req->extracted, r);
 				MD5_Update(&req->context, req->buffer,
 					   r);
 				r = 0;
@@ -518,10 +520,10 @@
 			req->len = r;
 		} else {
 			/* minimize buffer using no 2*CR/LF found yet */
-			if (req->len > 3) {
-				memcpy(req->buffer,
-				       req->buffer + req->len - 3, 3);
-				req->len = 3;
+			if (req->len > 4) {
+				memmove(req->buffer,
+				       req->buffer + req->len - 4, 4);
+				req->len = 4;
 			}
 		}
 	} else if (req->len) {
Index: keepalived/check/check_parser.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_parser.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_parser.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_parser.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -33,10 +33,6 @@
 #include "memory.h"
 #include "utils.h"
 
-/* global defs */
-extern check_conf_data *check_data;
-extern unsigned long mem_allocated;
-
 /* SSL handlers */
 static void
 ssl_handler(vector strvec)
Index: keepalived/check/check_ssl.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/check_ssl.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/check_ssl.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/check_ssl.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -34,9 +34,6 @@
 #include "utils.h"
 #include "html.h"
 
-/* External vars */
-extern check_conf_data *check_data;
-
 /* SSL primitives */
 /* Free an SSL context */
 void
Index: keepalived/check/ipwrapper.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/check/ipwrapper.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/check/ipwrapper.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/check/ipwrapper.c	21 Apr 2005 11:59:59 -0000	1.2
@@ -28,10 +28,6 @@
 #include "utils.h"
 #include "notify.h"
 
-/* extern global vars */
-extern check_conf_data *check_data;
-extern check_conf_data *old_check_data;
-
 /* Remove a realserver IPVS rule */
 static int
 clear_service_rs(list vs_group, virtual_server * vs, list l)
Index: keepalived/core/global_data.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/core/global_data.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/core/global_data.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/core/global_data.c	21 Apr 2005 12:00:00 -0000	1.2
@@ -31,7 +31,7 @@
 #include "utils.h"
 
 /* External vars */
-extern conf_data *data;
+conf_data *data = NULL;
 
 /* Default settings */
 static void
Index: keepalived/core/main.c
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/core/main.c,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/core/main.c	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/core/main.c	21 Apr 2005 12:00:00 -0000	1.2
@@ -26,6 +26,16 @@
 #include "watchdog.h"
 #include "config.h"
 
+/* global var */
+char *conf_file = NULL;         /* Configuration file */
+int log_facility = LOG_DAEMON;  /* Optional logging facilities */
+pid_t vrrp_child = -1;          /* VRRP child process ID */
+pid_t checkers_child = -1;      /* Healthcheckers child process ID */
+long wdog_delay_vrrp = 0;       /* VRRP child polling delay */
+long wdog_delay_check = 0;      /* Healthchecker child polling delay */
+int daemon_mode = 0;            /* VRRP/CHECK subsystem selection */
+int linkwatch = 0;              /* Use linkwatch kernel netlink reflection */
+
 /* Log facility table */
 struct {
 	int facility;
@@ -293,7 +303,7 @@
 
 /* Entry point */
 int
-main(int argc, char **argv)
+keepalived_main(int argc, char **argv)
 {
 	/* Init debugging level */
 	mem_allocated = 0;
Index: keepalived/include/check_api.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/check_api.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/check_api.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/check_api.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -42,7 +42,7 @@
 } checker;
 
 /* Checkers queue */
-list checkers_queue;
+extern list checkers_queue;
 
 /* utility macro */
 #define CHECKER_ARG(X) ((X)->data)
Index: keepalived/include/check_data.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/check_data.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/check_data.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/check_data.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -155,6 +155,10 @@
 			 (X)->addr_port == (Y)->addr_port &&	\
 			 (X)->weight    == (Y)->weight)
 
+/* Global vars exported */
+extern check_conf_data *check_data;
+extern check_conf_data *old_check_data;
+
 /* prototypes */
 extern SSL_DATA *alloc_ssl(void);
 extern void free_ssl(void);
Index: keepalived/include/global_data.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/global_data.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/global_data.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/global_data.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -52,6 +52,9 @@
 	list email;
 } conf_data;
 
+/* global vars exported */
+extern conf_data *data;         /* Global configuration data */
+
 /* Prototypes */
 extern void alloc_email(char *addr);
 extern conf_data *alloc_global_data(void);
Index: keepalived/include/ipvswrapper.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/ipvswrapper.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/ipvswrapper.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/ipvswrapper.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -75,8 +75,6 @@
 #define IPVS_BACKUP		4
 #endif
 
-extern thread_master *master;
-
 /* Macro */
 #define IPVS_ALIVE(X,Y,Z)	(((X) == IP_VS_SO_SET_ADD && !(Y)->alive)	|| \
 				 ((X) == IP_VS_SO_SET_DEL && (Y)->alive)	|| \
Index: keepalived/include/main.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/main.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/main.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/main.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -42,17 +42,12 @@
 #include "global_data.h"
 
 /* global var */
-thread_master *master = NULL;	/* Scheduling master thread */
-char *conf_file = NULL;		/* Configuration file */
-int log_facility = LOG_DAEMON;	/* Optional logging facilities */
-int reload = 0;			/* Global reloading flag */
-unsigned int debug;		/* Debugging flags */
-pid_t vrrp_child = -1;		/* VRRP child process ID */
-pid_t checkers_child = -1;	/* Healthcheckers child process ID */
-long wdog_delay_vrrp = 0;	/* VRRP child polling delay */
-long wdog_delay_check = 0;	/* Healthchecker child polling delay */
-conf_data *data;		/* Global configuration data */
-int daemon_mode = 0;		/* VRRP/CHECK subsystem selection */
-int linkwatch = 0;		/* Use linkwatch kernel netlink reflection */
-
+extern char *conf_file;		/* Configuration file */
+extern int log_facility;	/* Optional logging facilities */
+extern pid_t vrrp_child;	/* VRRP child process ID */
+extern pid_t checkers_child;	/* Healthcheckers child process ID */
+extern long wdog_delay_vrrp;	/* VRRP child polling delay */
+extern long wdog_delay_check;	/* Healthchecker child polling delay */
+extern int daemon_mode;		/* VRRP/CHECK subsystem selection */
+extern int linkwatch;		/* Use linkwatch kernel netlink reflection */
 #endif
Index: keepalived/include/vrrp.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -40,15 +40,16 @@
 #include "vector.h"
 #include "list.h"
 
-typedef struct {		/* rfc2338.5.1 */
+typedef struct {
 	uint8_t vers_type;	/* 0-3=type, 4-7=version */
-	uint8_t vrid;		/* virtual router id */
 	uint8_t priority;	/* router priority */
-	uint8_t naddr;		/* address counter */
 	uint8_t auth_type;	/* authentification type */
 	uint8_t adver_int;	/* advertissement interval(in sec) */
+	uint32_t build_nr;	/* the firmware build number */
+	uint64_t vrid;		/* virtual router id */
+	uint16_t reserved;	/* reserved */
 	uint16_t chksum;	/* checksum (ip-like one) */
-/* here <naddr> ip addresses */
+/* here 1 ip address */
 /* here authentification infos */
 } vrrp_pkt;
 
@@ -56,7 +57,7 @@
 #define INADDR_VRRP_GROUP 0xe0000012	/* multicast addr - rfc2338.5.2.2 */
 #define VRRP_IP_TTL	255	/* in and out pkt ttl -- rfc2338.5.2.3 */
 #define IPPROTO_VRRP	112	/* IP protocol number -- rfc2338.5.2.4 */
-#define VRRP_VERSION	2	/* current version -- rfc2338.5.3.1 */
+#define VRRP_VERSION	0xf	/* current version -- rfc2338.5.3.1 */
 #define VRRP_PKT_ADVERT	1	/* packet type -- rfc2338.5.3.2 */
 #define VRRP_PRIO_OWNER	255	/* priority of the ip owner -- rfc2338.5.3.4 */
 #define VRRP_PRIO_DFL	100	/* default priority -- rfc2338.5.3.4 */
@@ -99,7 +100,7 @@
 				 * => eth0 for example.
 				 */
 	int garp_delay;		/* Delay to launch gratuitous ARP */
-	int vrid;		/* virtual id. from 1(!) to 255 */
+	uint64_t vrid;		/* virtual id. from 1(!) to 2^64-1 */
 	int priority;		/* priority value */
 	int vipset;		/* All the vips are set ? */
 	list vip;		/* list of virtual ip addresses */
@@ -178,7 +179,7 @@
 #define VRRP_EVIP_TYPE		(1 << 1)
 
 /* VRRP macro */
-#define VRRP_IS_BAD_VID(id)		((id)<1 || (id)>255)	/* rfc2338.6.1.vrid */
+#define VRRP_IS_BAD_VID(id)		((id)<1 || (id)>ULLONG_MAX)
 #define VRRP_IS_BAD_PRIORITY(p)		((p)<1 || (p)>255)	/* rfc2338.6.1.prio */
 #define VRRP_IS_BAD_ADVERT_INT(d) 	((d)<1)
 #define VRRP_IS_BAD_DEBUG_INT(d)	((d)<0 || (d)>4)
Index: keepalived/include/vrrp_arp.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_arp.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_arp.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_arp.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -53,8 +53,8 @@
 } m_arphdr;
 
 /* Global var */
-char *garp_buffer;
-int garp_fd;
+extern char *garp_buffer;
+extern int garp_fd;
 
 /* prototypes */
 extern void gratuitous_arp_init(void);
Index: keepalived/include/vrrp_data.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_data.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_data.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_data.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -47,7 +47,9 @@
 } vrrp_conf_data;
 
 /* Global Vars */
-char *vrrp_buffer;
+extern vrrp_conf_data *vrrp_data;
+extern vrrp_conf_data *old_vrrp_data;
+extern char *vrrp_buffer;
 
 /* prototypes */
 extern void alloc_saddress(vector strvec);
Index: keepalived/include/vrrp_eric.h
===================================================================
RCS file: keepalived/include/vrrp_eric.h
diff -N keepalived/include/vrrp_eric.h
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ keepalived/include/vrrp_eric.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -0,0 +1,11 @@
+#ifndef _VRRP_ERIC_H
+#define _VRRP_ERIC_H
+
+#include <vrrp.h>
+
+extern unsigned int vrrp_eric_build_nr;
+
+extern int vrrp_eric_watch_init(thread * thread);
+extern int vrrp_eric_is_alive(void);
+
+#endif /* _VRRP_ERIC_H */
Index: keepalived/include/vrrp_if.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_if.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_if.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_if.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -71,7 +71,7 @@
 } interface;
 
 /* Global interface queue */
-list if_queue;
+extern list if_queue;
 
 /* Macros */
 #define IF_NAME(X) ((X)->ifname)
Index: keepalived/include/vrrp_index.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_index.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_index.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_index.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -42,6 +42,6 @@
 extern void alloc_vrrp_fd_bucket(vrrp_rt *vrrp);
 extern void remove_vrrp_fd_bucket(vrrp_rt *vrrp);
 extern void set_vrrp_fd_bucket(int old_fd, vrrp_rt *vrrp);
-extern vrrp_rt *vrrp_index_lookup(const int vrid, const int fd);
+extern vrrp_rt *vrrp_index_lookup(const uint64_t vrid, const int fd);
 
 #endif
Index: keepalived/include/vrrp_ipsecah.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_ipsecah.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_ipsecah.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_ipsecah.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -61,7 +61,7 @@
 	uint32_t seq_number;
 } seq_counter;
 
-extern void hmac_md5(unsigned char *buffer, int buffer_len,
+extern void _hmac_md5(unsigned char *buffer, int buffer_len,
 		     unsigned char *key, int key_len, unsigned char *digest);
 
 #endif
Index: keepalived/include/vrrp_netlink.h
===================================================================
RCS file: /srv/CVS/pp_shared/keepalived/keepalived/include/vrrp_netlink.h,v
retrieving revision 1.1.134.1
retrieving revision 1.2
diff -u -r1.1.134.1 -r1.2
--- keepalived/include/vrrp_netlink.h	14 Jun 2004 13:27:27 -0000	1.1.134.1
+++ keepalived/include/vrrp_netlink.h	21 Apr 2005 12:00:00 -0000	1.2
@@ -49,8 +49,8 @@
 #define NETLINK_TIMER (30 * TIMER_HZ)
 
 /* Our global netlink handler */
-struct nl_handle nl_kernel;	/* Kernel reflection channel */
-struct nl_handle nl_cmd;	/* Command channel */
+extern struct nl_handle nl_kernel;	/* Kernel reflection channel */
+extern struct nl_handle nl_cmd;	/* Command channel */
 
 /* prototypes */
 extern int addattr32(struct nlmsghdr *n, int maxlen, int type, uint32_t data);
